//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+                     Bloom Shader for ENB                       +
//+                         By soulwynd                            +
//+                    Adjustments by --JawZ--                     +
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+                          Version 3                             +
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++



//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Defines
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// EXTRA_X_PASS
// Adds another gaussian pass on the X axis, to give the bloom an
// anamorphic effect.
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  //  #define EXTRA_X_PASS

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Variables
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// BloomThreshold
// Overall Threshold for the bloom effect, so you can avoid darker
// areas in general.
//
// BloomChroma
// Saturation of the bloom effect.
//
// BloomLuma
// Luminosity of the bloom effect.
//
// LightSpreadThreshold
// Threshold of the first bloom added light. Named as light spread for
// convenience.
//
// LightSpreadPower
// Intensity of the first added light.
//
// GlowThreshold & GlowPower
// Exactly the same as above, but renamed as glow for convenience.
// You can use this one to add a smaller highlight to the bloom.
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//--BLOOM THRESHOLD-------------------------------------------------

    bool   SECTION_A <
        string UIName =  "A----------------------------------A";
    > = {false};
// REMOVE ABOVE IF YOU DON'T NEED IT AS A SECTION SEPERATION

    float2 BloomThreshold_E <
        string UIName="Bloom Threshold-EXT";         string UIWidget="Spinner";    float UIMin=0.0;
    > = {0.0, 0.0};

    float2 BloomThreshold_I <
        string UIName="Bloom Threshold-INT";            string UIWidget="Spinner";    float UIMin=0.0;
    > = {0.0, 0.0};

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//--BLOOM CHROMA----------------------------------------------------

    bool   SECTION_B <
        string UIName =  "B----------------------------------B";
    > = {false};
// REMOVE ABOVE IF YOU DON'T NEED IT AS A SECTION SEPERATION

    float2 BloomChroma_E <
        string UIName="Bloom Chroma-EXT";              string UIWidget="Spinner";    float UIMin=0.0;
    > = {1.0, 1.0};

    float2 BloomChroma_I <
        string UIName="Bloom Chroma-INT";         string UIWidget="Spinner";    float UIMin=0.0;
    > = {1.0, 1.0};

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//--BLOOM LUMA------------------------------------------------------

    bool   SECTION_C <
        string UIName =  "C----------------------------------C";
    > = {false};
// REMOVE ABOVE IF YOU DON'T NEED IT AS A SECTION SEPERATION

    float2 BloomLuma_E <
        string UIName="Bloom Luma-EXT";            string UIWidget="Spinner";    float UIMin=0.0;
    > = {1.0, 1.0};

    float2 BloomLuma_I <
        string UIName="Bloom Luma-INT";              string UIWidget="Spinner";    float UIMin=0.0;
    > = {1.0, 1.0};

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//--BLOOM SPREAD THRESHOLD------------------------------------------

    bool   SECTION_D <
        string UIName =  "D----------------------------------D";
    > = {false};
// REMOVE ABOVE IF YOU DON'T NEED IT AS A SECTION SEPERATION

    float2 LightSpreadThreshold_E <
        string UIName="Light Spread Threshold-EXT";      string UIWidget="Spinner";    float UIMin=0.0;
    > = {0.0, 0.0};

    float2 LightSpreadThreshold_I <
        string UIName="Light Spread Threshold-INT";      string UIWidget="Spinner";    float UIMin=0.0;
    > = {0.0, 0.0};

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//--BLOOM SPREAD POWER----------------------------------------------

    bool   SECTION_E <
        string UIName =  "E----------------------------------E";
    > = {false};
// REMOVE ABOVE IF YOU DON'T NEED IT AS A SECTION SEPERATION

    float2 LightSpreadPower_E <
        string UIName="Light Spread Power-EXT";          string UIWidget="Spinner";    float UIMin=0.0;
    > = {1.0, 1.0};

    float2 LightSpreadPower_I <
        string UIName="Light Spread Power-INT";          string UIWidget="Spinner";    float UIMin=0.0;
    > = {1.0, 1.0};

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//--BLOOM GLOW THRESHOLD--------------------------------------------

    bool   SECTION_F <
        string UIName =  "F----------------------------------F";
    > = {false};
// REMOVE ABOVE IF YOU DON'T NEED IT AS A SECTION SEPERATION

    float2 GlowThreshold_E <
        string UIName="Glow Threshold-EXT";              string UIWidget="Spinner";    float UIMin=0.0;
    > = {0.0, 0.0};

    float2 GlowThreshold_I <
        string UIName="Glow Threshold-INT";              string UIWidget="Spinner";    float UIMin=0.0;
    > = {0.0, 0.0};

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//--BLOOM GLOW POWER------------------------------------------------

    bool   SECTION_G <
        string UIName =  "G----------------------------------G";
    > = {false};
// REMOVE ABOVE IF YOU DON'T NEED IT AS A SECTION SEPERATION

    float2 GlowPower_E <
        string UIName="Glow Power-EXT";                  string UIWidget="Spinner";    float UIMin=0.0;
    > = {1.0, 1.0};

    float2 GlowPower_I <
        string UIName="Glow Power-INT";                  string UIWidget="Spinner";    float UIMin=0.0;
    > = {1.0, 1.0};

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//--BLOOM MULTIPLICATIVE THRESHOLD----------------------------------

    bool   SECTION_H <
        string UIName =  "H----------------------------------H";
    > = {false};
// REMOVE ABOVE IF YOU DON'T NEED IT AS A SECTION SEPERATION

    float2 MultThreshold_E <
        string UIName="Multiplicative Threshold-EXT";    string UIWidget="Spinner";    float UIMin=0.0;
    > = {0.0, 0.0};

    float2 MultThreshold_I <
        string UIName="Multiplicative Threshold-INT";    string UIWidget="Spinner";    float UIMin=0.0;
    > = {0.0, 0.0};

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//--BLOOM MULTIPLICATIVE POWER--------------------------------------

    bool   SECTION_I <
        string UIName =  "I----------------------------------I";
    > = {false};
// REMOVE ABOVE IF YOU DON'T NEED IT AS A SECTION SEPERATION

    float2 MultPower_E <
        string UIName="Multiplicative Power-EXT";        string UIWidget="Spinner";    float UIMin=0.0;
    > = {1.0, 1.0};

    float2 MultPower_I <
        string UIName="Multiplicative Power-INT";        string UIWidget="Spinner";    float UIMin=0.0;
    > = {1.0, 1.0};


//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//--BLOOM BLUR RADIUS----------------------------------------------

    bool   SECTION_J <
        string UIName =  "J----------------------------------J";
    > = {false};
// REMOVE ABOVE IF YOU DON'T NEED IT AS A SECTION SEPERATION

    float2 BRadius_E <
        string UIName="Blur Radius-EXT";        string UIWidget="Spinner";    float UIMin=0.0;
    > = {1.0, 1.0};

    float2 BRadius_I <
        string UIName="Blur Radius-INT";        string UIWidget="Spinner";    float UIMin=0.0;
    > = {1.0, 1.0};


//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//--BLOOM BLUR RADIUS X-PASS----------------------------------------
  #ifdef EXTRA_X_PASS
    bool   SECTION_K <
        string UIName =  "K----------------------------------K";
    > = {false};
// REMOVE ABOVE IF YOU DON'T NEED IT AS A SECTION SEPERATION

    float2 BRadiusXPass_E <
        string UIName="Blur Radius X-Pass-EXT";        string UIWidget="Spinner";    float UIMin=0.0;
    > = {1.0, 1.0};

    float2 BRadiusXPass_I <
        string UIName="Blur Radius X-Pass-INT";        string UIWidget="Spinner";    float UIMin=0.0;
    > = {1.0, 1.0};
  #endif



//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// EXTERNAL PARAMETERS BEGINS HERE, SHOULD NOT BE MODIFIED UNLESS YOU KNOW WHAT YOU ARE DOING!!!
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

//Keyboard controlled temporary variables (in some versions they exist in the config file).
//Press and hold key 1,2,3...8 together with PageUp or PageDown to modify. By default all set to 1.0
float4 tempF1;                    // 0,1,2,3
float4 tempF2;                    // 5,6,7,8
float4 tempF3;                    // 9,0
float4 ScreenSize;                // x=Width, y=1/Width, z=ScreenScaleY, w=1/ScreenScaleY
float4 Timer;                     // x=generic timer in range 0..1, period of 16777216 ms (4.6 hours), w=frame time elapsed (in seconds)
float  ENightDayFactor;           // Changes in range 0..1, 0 = night time, 1 = day time
float  EInteriorFactor;           // Changes 0 or 1. 0 = exterior, 1 = interior
float  FieldOfView;               // FoV in degrees
float  EAdaptiveQualityFactor;    // Changes in range 0..1, 0 means full quality, 1 lowest dynamic quality (0.33, 0.66 are limits for quality levels)
float4 TempParameters;            // Additional info for computations
float4 BloomParameters;           // BloomRadius1, BloomRadius2, BloomBlueShiftAmount, BloomContrast



// SAMPLERS

texture2D texBloom1;
texture2D texBloom2;
texture2D texBloom3;
texture2D texBloom4;
texture2D texBloom5;
texture2D texBloom6;
texture2D texBloom7;//additional bloom tex
texture2D texBloom8;//additional bloom tex

sampler2D SamplerBloom1 = sampler_state
{
    Texture   = <texBloom1>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;//NONE;
    AddressU  = Clamp;
    AddressV  = Clamp;
    SRGBTexture=FALSE;
    MaxMipLevel=0;
    MipMapLodBias=0;
};

sampler2D SamplerBloom2 = sampler_state
{
    Texture   = <texBloom2>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;//NONE;
    AddressU  = Clamp;
    AddressV  = Clamp;
    SRGBTexture=FALSE;
    MaxMipLevel=0;
    MipMapLodBias=0;
};

sampler2D SamplerBloom3 = sampler_state
{
    Texture   = <texBloom3>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;//NONE;
    AddressU  = Clamp;
    AddressV  = Clamp;
    SRGBTexture=FALSE;
    MaxMipLevel=0;
    MipMapLodBias=0;
};

sampler2D SamplerBloom4 = sampler_state
{
    Texture   = <texBloom4>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;//NONE;
    AddressU  = Clamp;
    AddressV  = Clamp;
    SRGBTexture=FALSE;
    MaxMipLevel=0;
    MipMapLodBias=0;
};

sampler2D SamplerBloom5 = sampler_state
{
    Texture   = <texBloom5>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;//NONE;
    AddressU  = Clamp;
    AddressV  = Clamp;
    SRGBTexture=FALSE;
    MaxMipLevel=0;
    MipMapLodBias=0;
};

sampler2D SamplerBloom6 = sampler_state
{
    Texture   = <texBloom6>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;//NONE;
    AddressU  = Clamp;
    AddressV  = Clamp;
    SRGBTexture=FALSE;
    MaxMipLevel=0;
    MipMapLodBias=0;
};

sampler2D SamplerBloom7 = sampler_state
{
    Texture   = <texBloom7>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;//NONE;
    AddressU  = Clamp;
    AddressV  = Clamp;
    SRGBTexture=FALSE;
    MaxMipLevel=0;
    MipMapLodBias=0;
};

sampler2D SamplerBloom8 = sampler_state
{
    Texture   = <texBloom8>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;//NONE;
    AddressU  = Clamp;
    AddressV  = Clamp;
    SRGBTexture=FALSE;
    MaxMipLevel=0;
    MipMapLodBias=0;
};



// DATA STRUCTURE

struct VS_OUTPUT_POST
{
    float4 vpos     : POSITION;
    float2 txcoord0 : TEXCOORD0;
};

struct VS_INPUT_POST
{
    float3 pos      : POSITION;
    float2 txcoord0 : TEXCOORD0;
};



// FUNCTIONS

// ND-IE Separation
    float3 NDIEFactor( float3 NIGHTINT, float3 DAYINT, float3 NIGHTEXT, float3 DAYEXT )
    {
      if (EInteriorFactor) {
        return lerp(NIGHTEXT, DAYEXT, ENightDayFactor);
      } else {
        return lerp(NIGHTINT, DAYINT, ENightDayFactor);
      };
    }



// VERTEX SHADER

VS_OUTPUT_POST VS_Bloom(VS_INPUT_POST IN)
{
    VS_OUTPUT_POST OUT;

    OUT.vpos=float4(IN.pos.x,IN.pos.y,IN.pos.z,1.0);

    OUT.txcoord0.xy=IN.txcoord0.xy+TempParameters.xy;//1.0/(bloomtexsize*2.0)

    return OUT;
}



// BLUR TYPE

//Gaussian
float4 BlurX(float2 coords : TEXCOORD0) : COLOR
{
  float BRadius = NDIEFactor (BRadius_E.x, BRadius_E.y, BRadius_I.x, BRadius_I.y);

  const float weight[5] = {0.2270270270, 0.0972972973, 0.0608108108, 0.02702702705, 0.0081081081};

    float4 ret = tex2D(SamplerBloom1, coords) * weight[0];

    float2 screenfact = TempParameters.z;
    screenfact.y *= ScreenSize.z;
    screenfact.xy *= BloomParameters.xy * BRadius;

    for(int i=1; i < 5; i++)
    {
        ret += tex2D(SamplerBloom1, coords + float2(i*screenfact.x, 0.0)) * weight[i];
        ret += tex2D(SamplerBloom1, coords - float2(i*screenfact.x, 0.0)) * weight[i];
    }

    return ret;
}


float4 BlurY(float2 coords : TEXCOORD0) : COLOR
{
  float BRadius = NDIEFactor (BRadius_E.x, BRadius_E.y, BRadius_I.x, BRadius_I.y);

  const float weight[5] = {0.2270270270, 0.0972972973, 0.0608108108, 0.02702702705, 0.0081081081};

    float4 ret = tex2D(SamplerBloom1, coords) * weight[0];

    float2 screenfact = TempParameters.z;
    screenfact.y *= ScreenSize.z;
    screenfact.xy *= BloomParameters.xy * BRadius;

  #ifdef EXTRA_X_PASS
  float BRadiusXPass = NDIEFactor (BRadiusXPass_E.x, BRadiusXPass_E.y, BRadiusXPass_I.x, BRadiusXPass_I.y);
    float2 screenfactXpass = TempParameters.z;
    screenfactXpass.y *= ScreenSize.z;
    screenfactXpass.xy *= BloomParameters.x * BRadiusXPass;
  #endif

    for(int i=1; i < 5; i++) 
    {
        ret += tex2D(SamplerBloom1, coords + float2(0.0, i*screenfact.y)) * weight[i];
        ret += tex2D(SamplerBloom1, coords - float2(0.0, i*screenfact.y)) * weight[i];

      #ifdef EXTRA_X_PASS
        ret += tex2D(SamplerBloom1, coords + float2(i*screenfactXpass.x, 0.0)) * weight[i];
        ret += tex2D(SamplerBloom1, coords - float2(i*screenfactXpass.x, 0.0)) * weight[i];
      #endif
    }

    return ret;
}



// PIXEL SHADERS

float4 PS_BloomPrePass(VS_OUTPUT_POST In) : COLOR
{
  float BloomThreshold = NDIEFactor (BloomThreshold_E.x, BloomThreshold_E.y, BloomThreshold_I.x, BloomThreshold_I.y);
  float BloomChroma    = NDIEFactor (BloomChroma_E.x, BloomChroma_E.y, BloomChroma_I.x, BloomChroma_I.y);
  float BloomLuma      = NDIEFactor (BloomLuma_E.x, BloomLuma_E.y, BloomLuma_I.x, BloomLuma_I.y);

    float4 bloom;

    bloom =tex2D(SamplerBloom1, In.txcoord0.xy);
    bloom +=tex2D(SamplerBloom3, In.txcoord0.xy);
    bloom +=tex2D(SamplerBloom4, In.txcoord0.xy);
    bloom +=tex2D(SamplerBloom7, In.txcoord0.xy);
    bloom +=tex2D(SamplerBloom8, In.txcoord0.xy);

    float4 srcbloom=bloom;

    bloom-= BloomThreshold * 0.1;

    float4 chromaluma = sqrt((bloom.x*bloom.x*0.212395f)+(bloom.y*bloom.y*0.701049f)+(bloom.z*bloom.z*0.086556f)); // dot(bloom.rgb, float3(0.2126, 0.7152, 0.0722));


    chromaluma.rgb = bloom.rgb - chromaluma.w;

    chromaluma.rgb *= BloomChroma;
    chromaluma.w *= BloomLuma;

    bloom.rgb = chromaluma.rgb + chromaluma.w;


    bloom.w = 1.0;

    bloom = saturate(bloom);

    return bloom;
}

float4 PS_BloomTexture1(VS_OUTPUT_POST In) : COLOR
{
    float4 bloom = BlurX(In.txcoord0.xy);

    bloom.w = 1.0;

    return bloom;
}

float4 PS_BloomTexture2(VS_OUTPUT_POST In) : COLOR
{
    float4 bloom = BlurY(In.txcoord0.xy);

    bloom.w=1.0;

    return bloom;
}

float4 PS_BloomPostPass(VS_OUTPUT_POST In) : COLOR
{
  float LightSpreadThreshold = NDIEFactor (LightSpreadThreshold_E.x, LightSpreadThreshold_E.y, LightSpreadThreshold_I.x, LightSpreadThreshold_I.y);
  float LightSpreadPower     = NDIEFactor (LightSpreadPower_E.x, LightSpreadPower_E.y, LightSpreadPower_I.x, LightSpreadPower_I.y);
  float GlowThreshold        = NDIEFactor (GlowThreshold_E.x, GlowThreshold_E.y, GlowThreshold_I.x, GlowThreshold_I.y);
  float GlowPower            = NDIEFactor (GlowPower_E.x, GlowPower_E.y, GlowPower_I.x, GlowPower_I.y);
  float MultThreshold        = NDIEFactor (MultThreshold_E.x, MultThreshold_E.y, MultThreshold_I.x, MultThreshold_I.y);
  float MultPower            = NDIEFactor (MultPower_E.x, MultPower_E.y, MultPower_I.x, MultPower_I.y);

    float4 bloom;

    float4 tap;

    tap =tex2D(SamplerBloom1, In.txcoord0);
    tap +=tex2D(SamplerBloom3, In.txcoord0);
    tap +=tex2D(SamplerBloom4, In.txcoord0);
    tap +=tex2D(SamplerBloom7, In.txcoord0);
    tap +=tex2D(SamplerBloom8, In.txcoord0);

    bloom = max(0.0, (tap - LightSpreadThreshold * 0.1) * LightSpreadPower * (1.0 - tex2D(SamplerBloom5, In.txcoord0)));
    bloom += max(0.0, (tap - GlowThreshold * 0.1) * GlowPower);
    bloom += max(0.0, (tap - MultThreshold * 0.1) * MultPower) * bloom;

    bloom.w = 1.0;

    return bloom;
}



// TECNHIQUES

technique BloomPrePass
{
    pass p0
    {
    VertexShader = compile vs_3_0 VS_Bloom();
    PixelShader  = compile ps_3_0 PS_BloomPrePass();

    ColorWriteEnable=ALPHA|RED|GREEN|BLUE;
    CullMode=NONE;
    AlphaBlendEnable=FALSE;
    AlphaTestEnable=FALSE;
    SEPARATEALPHABLENDENABLE=FALSE;
    FogEnable=FALSE;
    SRGBWRITEENABLE=FALSE;
    }
}

technique BloomTexture1
{
    pass p0
    {
    VertexShader = compile vs_3_0 VS_Bloom();
    PixelShader  = compile ps_3_0 PS_BloomTexture1();

    ColorWriteEnable=ALPHA|RED|GREEN|BLUE;
    CullMode=NONE;
    AlphaBlendEnable=FALSE;
    AlphaTestEnable=FALSE;
    SEPARATEALPHABLENDENABLE=FALSE;
    FogEnable=FALSE;
    SRGBWRITEENABLE=FALSE;
    }
}

technique BloomTexture2
{
    pass p0
    {
    VertexShader = compile vs_3_0 VS_Bloom();
    PixelShader  = compile ps_3_0 PS_BloomTexture2();

    ColorWriteEnable=ALPHA|RED|GREEN|BLUE;
    CullMode=NONE;
    AlphaBlendEnable=FALSE;
    AlphaTestEnable=FALSE;
    SEPARATEALPHABLENDENABLE=FALSE;
    FogEnable=FALSE;
    SRGBWRITEENABLE=FALSE;
    }
}

technique BloomPostPass
{
    pass p0
    {
    VertexShader = compile vs_3_0 VS_Bloom();
    PixelShader  = compile ps_3_0 PS_BloomPostPass();

    ColorWriteEnable=ALPHA|RED|GREEN|BLUE;
    CullMode=NONE;
    AlphaBlendEnable=FALSE;
    AlphaTestEnable=FALSE;
    SEPARATEALPHABLENDENABLE=FALSE;
    FogEnable=FALSE;
    SRGBWRITEENABLE=FALSE;
    }
}